<?php
namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;


class relAlteracaoDePrecoService {

	public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }
    
    public function find($conditions) {
        $params = array(
            ":DTALTERACAOI"=>$conditions['DTALTERACAO'][0],
            ":DTALTERACAOF"=>$conditions['DTALTERACAO'][1],  
         	":CDFILIAL" => $conditions['CDFILIAL'],
         	":CDTABULTPREC" =>$conditions['CDTABULTPREC'],
         	":CDOPERADOR"=>$conditions['CDOPERADOR'],
         	":CDARVPRODF" => $conditions['CDARVPRODF'],
         	":CDARVPRODI" => $conditions['CDARVPRODI'],
         	":CDPRODLIST" => $conditions['CDPRODLIST'],
         	":PRODNIV" => $conditions['PRODNIV'],
         	":TCDPRODUTO" => $conditions['TCDPRODUTO']
 		);
 		return $this->entityManager->getConnection()->fetchAll(self::GET_FILD, $params);
    }

    const GET_FILD = "

                SELECT
                    P.NMPRODUTO,
                    T.NRORG,
                    T.CDFILIAL,
                    T.CDTABULTPREC,
                    T.DTALTERACAO,
                    T.CDOPERADOR,
                    T.CDPRODUTO,
                    T.VRPRODATUAL,
                    T.VRPROTANT,
                    P.CDARVPROD,
                    (T.CDPRODUTO || ' - ' || P.NMPRODUTO) AS NMCDPROD

                FROM
                    TABEULTPREC  T
                INNER JOIN PRODUTO P ON (T.CDPRODUTO = P.CDPRODUTO)
                WHERE    
                    ( INSTR(:CDFILIAL, T.CDFILIAL) > 0 )
                    AND ( INSTR(:CDTABULTPREC, T.CDTABULTPREC) > 0 )
                    AND T.DTALTERACAO BETWEEN :DTALTERACAOI AND :DTALTERACAOF
                    AND ( INSTR(:CDOPERADOR, T.CDOPERADOR) > 0 OR ( :CDOPERADOR = 'T' ))
                        AND ( ( ( ( ( INSTR(:CDPRODLIST, P.CDPRODUTO) > 0 ) OR ( P.CDARVPROD BETWEEN :CDARVPRODI AND :CDARVPRODF ) ) ) OR ( P.CDARVPROD LIKE :PRODNIV ) )OR ( :TCDPRODUTO = 'T' ) )
                
                
                GROUP BY
                    P.CDARVPROD,
                    P.NMPRODUTO, T.CDFILIAL,
                    T.CDTABULTPREC,
                    T.DTALTERACAO,
                    T.CDOPERADOR,
                    T.CDPRODUTO,
                    T.VRPRODATUAL,
                    T.VRPROTANT,
                    T.NRORG
                ";  
}